function moveblock()
	local moving = findfeature(nil,"is","move")
	local isback = findfeature(nil,"is","back")
	local isshift = findfeature(nil,"is","shift")
	local isfollow = findfeature(nil,"follow",nil)
	
	if (isfollow ~= nil) then
		for h,j in ipairs(isfollow) do
			local allfollows = findall(j)
			
			if (#allfollows > 0) then
				for k,l in ipairs(allfollows) do
					local unit = mmf.newObject(l)
					local x,y,name = unit.values[XPOS],unit.values[YPOS],unit.strings[UNITNAME]
					local unitrules = {}
					
					if (unit.strings[UNITTYPE] == "text") then
						name = "text"
					end
					
					if (featureindex[name] ~= nil) then					
						for a,b in ipairs(featureindex[name]) do
							if (b[5] == nil) then
								if (b[2] == "follow") then
									table.insert(unitrules, {b[1],b[2],b[3][1]})
								end
							else
								if (b[4] == "follow") then
									if ison({name,b[3]},unitid) then
										table.insert(unitrules, b)
									end
								end
							end
						end
					end
					
					local follow = xthis(unitrules,"follow")
					
					if (#follow > 0) then
						local distance = 9999
						local targetdir = -1
						
						for i,v in ipairs(follow) do
							local these = findall({v})
							
							if (#these > 0) then
								for a,b in ipairs(these) do
									if (b ~= unit.fixed) then
										local funit = mmf.newObject(b)
										
										local fx,fy = funit.values[XPOS],funit.values[YPOS]
										
										local xdir = fx-x
										local ydir = fy-y
										local dist = math.abs(xdir) + math.abs(ydir)
										local fdir = -1
										
										if (math.abs(xdir) <= math.abs(ydir)) then
											if (ydir >= 0) then
												fdir = 3
											else
												fdir = 1
											end
										else
											if (xdir > 0) then
												fdir = 0
											else
												fdir = 2
											end
										end
										
										if (dist < distance) then
											distance = dist
											targetdir = fdir
										end
									end
								end
							end
						end
		
						if (targetdir >= 0) then
							updatedir(unit.fixed,targetdir)
						end
					end
				end
			end
		end
	end
	
	if (moving ~= nil) then
		for i,v in ipairs(moving) do
			local these = findall(v)
			
			if (#these > 0) then
				for a,unitid in ipairs(these) do
					local unit = mmf.newObject(unitid)
					local dir = unit.values[DIR]
					
					local isyou = hasfeature(v[1],"is","you",unitid)
					local follow = hasfeature(v[1],"follow",nil,unitid)
					
					if (isyou == nil) and (unit.values[MOVED] == 0) then
						local d = ndirs[dir+1]
						local ox = d[1]
						local oy = d[2]

						local boop = move(unitid,ox,oy)
						
						if (boop == 1) and (follow == nil) then
							local newdir = rotate(dir)
							
							d = ndirs[newdir+1]
							ox = d[1]
							oy = d[2]
							
							updatedir(unitid,newdir)
							
							if (unit.values[MOVED] == 0) then
								move(unitid,ox,oy,newdir)
							end
						end
					elseif (isyou ~= nil) then
						local d = ndirs[dir+1]
						local ox = d[1]
						local oy = d[2]
						unit.values[PUSHED] = 4

						local boop = move(unitid,ox,oy,dir)
					end
				end
			end
		end
	end
	
	if (isback ~= nil) then
		for i,v in ipairs(isback) do
			local these = findall(v)
			
			if (#these > 0) then
				for a,unitid in ipairs(these) do
					local unit = mmf.newObject(unitid)
					
					unit.values[A] = unit.values[A] + 2
					
					if (undobuffer[unit.values[A]] ~= nil) then
						doback(unit,undobuffer[unit.values[A]])
					end
				end
			end
		end
	end
	
	if (isshift ~= nil) then
		local textmove = findfeature("text","is","move")
		local textyou = findfeature("text","is","you")
		local dotext = false
		
		if (textmove ~= nil) or (textyou ~= nil) then
			dotext = true
		end
		
		for i,v in ipairs(isshift) do
			local these = findall(v)
			
			if (#these > 0) then
				for a,unitid in ipairs(these) do
					local unit = mmf.newObject(unitid)
					local x,y,dir = unit.values[XPOS],unit.values[YPOS],unit.values[DIR]
					
					local things = findallhere(x,y,unitid)
					
					if (#things > 0) then
						for e,f in ipairs(things) do
							local newunit = mmf.newObject(f)
							local name = newunit.strings[UNITNAME] 
							local hasshift = hasfeature(name,"is","shift",f)
							
							if (newunit.values[MOVED] == 0) or ((newunit.values[MOVED] == 1) and (newunit.values[DIR] ~= dir) and (hasshift == nil)) then
								if (((newunit.strings[UNITTYPE] ~= "text") and (dotext == false)) or dotext) and (issafe(f) == false) then
									local drs = ndirs[dir+1]
									local ox = drs[1]
									local oy = drs[2]
									
									if issolid(f) then
										move(f,ox,oy,dir,true)
									else
										move(f,ox,oy,dir,true,2)
									end
								end
							end
							
							if (hasshift ~= nil) and ((unit.values[MOVED] == 0) or ((unit.values[MOVED] == 1) and (newunit.values[DIR] ~= dir))) then
								local drs = ndirs[newunit.values[DIR]+1]
								local ox = drs[1]
								local oy = drs[2] 
								
								if issolid(unitid) then
									move(unitid,ox,oy,newunit.values[DIR],true)
								else
									move(unitid,ox,oy,newunit.values[DIR],true,2)
								end
							end
						end
					end
				end
			end
		end
	end
end

function block()
	local delthese = {}
	local unitsnow = #units
	
	for k,unit in ipairs(units) do
		if (k <= unitsnow) then
			local unitrules = {}
			local unitid = unit.fixed
			local name = unit.strings[UNITNAME]
			local x,y,dir,moved,id = unit.values[XPOS],unit.values[YPOS],unit.values[DIR],unit.values[MOVED],unit.values[ID]
			local ox,oy = 0,0
			local online = true
			
			if (unit.strings[UNITTYPE] == "text") then
				name = "text"
			end
			
			if (featureindex[name] ~= nil) then
				for a,b in ipairs(featureindex[name]) do
					if (b[5] == nil) then
						table.insert(unitrules, {b[1],b[2],b[3][1]})
					else
						if ison({name,b[3]},unitid) then
							table.insert(unitrules, b)
						end
					end
				end
	
				local isice = isthis(unitrules,"melt")
				local ismove = isthis(unitrules,"move")
				local isyou = isthis(unitrules,"you")
				local ispush = isthis(unitrules,"push")
				local ispull = isthis(unitrules,"pull")
				local iskill = isthis(unitrules,"kill")
				local iswin = isthis(unitrules,"win")
				local isbest = isthis(unitrules,"best")
				local isgrow = isthis(unitrules,"grow")
				local istele = isthis(unitrules,"tele")
				local isweak = isthis(unitrules,"weak")
				local isshut = isthis(unitrules,"shut")
				local ishide = isthis(unitrules,"hide")
				local isback = isthis(unitrules,"back")
				local isbonus = isthis(unitrules,"bonus")
				local make = xthis(unitrules,"make")
				
				if (isback == false) then
					unit.values[A] = 0
				end
					
				if ispush or ismove or isyou or ispull then
					local sink = findfeature(nil,"is","sink")
					
					if (sink ~= nil) then
						for i,v in ipairs(sink) do
							local water = findtype(v,x,y,0)
							
							if (#water > 0) then
								for a,b in ipairs(water) do
									if (b > 0) and (issafe(unitid) == false) then
										table.insert(delthese, {unitid, 3})
										online = false
										
										if (b ~= unitid) and (issafe(b) == false) then
											table.insert(delthese, {b, 0})
										end
										
										break
									end
								end
							end
						end
					end
				end
				
				if isshut then
					local open = findfeature(nil,"is","open")
					
					if (open ~= nil) then
						for i,v in ipairs(open) do
							local key = findtype(v,x,y,0)
							
							if (#key > 0) then
								for a,b in ipairs(key) do
									if (b > 0) and (issafe(unitid) == false) then
										table.insert(delthese, {unitid, 4})
										MF_particles("unlock",x,y,30)
										online = false
										
										if (b ~= unitid) and (issafe(b) == false) then
											table.insert(delthese, {b, 0})
										end
										
										break
									end
								end
							end
						end
					end
				end
				
				if isweak and (issafe(unitid) == false) then
					local stuff = findallhere(x,y)
					
					if (#stuff > 0) then
						for i,v in ipairs(stuff) do
							local vunit = mmf.newObject(v)
							local thistype = vunit.strings[UNITTYPE]
							if (v ~= unitid) and (thistype ~= "text") then
								table.insert(delthese, {unitid, 4})
								online = false
								break
							end
						end
					end
				end
				
				if isyou and online and (isgone(unitid) == false) then
					local win = findfeature(nil,"is","win")
					
					if (win ~= nil) then
						for a,b in ipairs(win) do
							if (b[1] ~= "empty") then
								local flag = findtype(b,x,y,0)
								
								if (#flag > 0) then
									for c,d in ipairs(flag) do
										if (isgone(d) == false) then
											MF_particles("win",x,y,10)
											MF_win()
											break
										end
									end
								end
							end
						end
					end
					
					local kill = findfeature(nil,"is","kill")
					local allkill = findfeature("all","is","kill")
					
					if (kill ~= nil) and (allkill == nil) then
						for a,b in ipairs(kill) do
							if (b[1] ~= "empty") then
								local skull = findtype(b,x,y,0)
								
								if (#skull > 0) and (issafe(unitid) == false) then
									table.insert(delthese, {unitid, 5})
								end
							end
						end
					end
					
					local bonus = findfeature(nil,"is","bonus")
					
					if (bonus ~= nil) then
						for a,b in ipairs(bonus) do
							if (b[1] ~= "empty") then
								local flag = findtype(b,x,y,0)
								
								if (#flag > 0) then
									for c,d in ipairs(flag) do
										if (isgone(d) == false) then
											MF_particles("bonus",x,y,10)
											MF_bonus()
											table.insert(delthese, {d, 5})
										end
									end
								end
							end
						end
					end
				end
				
				if isice then
					local hot = findfeature(nil,"is","hot")
					
					if (hot ~= nil) then
						for a,b in ipairs(hot) do
							local lava = findtype(b,x,y,0)
						
							if (#lava > 0) and (issafe(unitid) == false) then
								MF_particles("smoke",x,y,5)
								table.insert(delthese, {unitid, 5})
								online = false
							end
						end
					end
				end
				
				if iskill then
					local player = findfeature(nil,"is","you")
					
					if (player ~= nil) then
						for i,v in ipairs(player) do
							local skull = findtype(v,x,y,0)
							
							if (#skull > 0) then
								for a,b in ipairs(skull) do
									if (b > 0) and (issafe(b) == false) then
										table.insert(delthese, {b, 5})
									end
								end
							end
						end
					end
				end
				
				if iswin and online then
					local player = findfeature(nil,"is","you")
					
					if (player ~= nil) then
						for a,b in ipairs(player) do
							local flag = findtype(b,x,y,0)
							
							if (#flag > 0) then
								for c,d in ipairs(flag) do
									if (isgone(d) == false) then
										MF_particles("win",x,y,10)
										MF_win()
										break
									end
								end
							end
						end
					end
				end
				
				if isbonus and online then
					local player = findfeature(nil,"is","you")
					
					if (player ~= nil) then
						for a,b in ipairs(player) do
							local flag = findtype(b,x,y,0)
							
							if (#flag > 0) then
								for c,d in ipairs(flag) do
									if (isgone(d) == false) then
										MF_particles("bonus",x,y,10)
										MF_bonus()
										table.insert(delthese, {unitid, 5})
										online = false
									end
								end
							end
						end
					end
				end
				
				if (#make > 0) then
					local thingshere = findallhere(x,y)
					
					for i,v in ipairs(make) do
						local domake = true
						local exists = false
						
						if (v ~= "text") and (v ~= "all") then
							for a,b in ipairs(materials) do
								if (b == v) then
									exists = true
								end
							end
						else
							exists = true
						end
						
						if exists then
							if (#thingshere > 0) then
								for a,b in ipairs(thingshere) do
									local thing = mmf.newObject(b)
									local thingname = thing.strings[UNITNAME]
									
									if (thingname == v) or ((thing.strings[UNITTYPE] == "text") and (v == "text")) then
										domake = false
									end
								end
							end
							
							if domake then
								if (v ~= "empty") and (v ~= "all") and (v ~= "text") then
									create(v,x,y,dir,x,y)
								elseif (v == "all") then
									for a,b in ipairs(materials) do
										local ishere = findtype(b,x,y,0)
										
										if (#ishere == 0) then
											create(b,x,y,dir,x,y)
										end
									end
								elseif (v == "text") then
									if (name ~= "empty") and (name ~= "text") and (name ~= "all") then
										create("text_" .. name,x,y,dir,x,y)
										updatecode = 1
									end
								end
							end
						end
					end
				end
				
				if isgrow then
					for i=1,4 do
						local drs = ndirs[i]
						ox = drs[1]
						oy = drs[2]
						
						local valid = true
						local obs = findobstacle(x+ox,y+oy)
						local tileid = x+ox + (y+oy) * roomsize
						
						if (#obs > 0) then
							for a,b in ipairs(obs) do
								if (b == -1) then
									valid = false
								elseif (b > 0) then
									local bunit = mmf.newObject(b)
									local obsname = bunit.strings[UNITNAME]
									local obstype = bunit.strings[UNITTYPE]
									
									if (obstype == "text") then
										obsname = "text"
									end
									
									local obsstop = hasfeature(obsname,"is","stop",b)
									local obspush = hasfeature(obsname,"is","push",b)
									local obspull = hasfeature(obsname,"is","pull",b)
									local obsyou = hasfeature(obsname,"is","you",b)
									
									if (obsstop ~= nil) or (obspush ~= nil) or (obsyou ~= nil) or (obspull ~= nil) or (obsname == name) or (obstype == "text") then
										valid = false
									end
									
									--valid = false
								end
							end
						end
						
						if valid then
							local newunit = copy(unitid,x+ox,y+oy)
							
							if isgone(newunit) then
								delete(newunit,1)
							end
						end
					end
				end
				
				if istele then
					local targets = findallhere(x,y)
					local telethis = false
					local telethisx,telethisy = 0,0
					local swaptele = {}
					
					if (#targets > 0) then
						for i,v in ipairs(targets) do
							local vunit = mmf.newObject(v)
							local thistype = vunit.strings[UNITTYPE]
							if (issafe(v) == false) and (thistype ~= "text") then
								local targetname = vunit.strings[UNITNAME]
								if (objectdata[v] == nil) then
									objectdata[v] = {}
								end
								
								local odata = objectdata[v]
								
								if (odata.tele == nil) then
									if (targetname ~= name) and (v ~= unitid) then
										local teles = findall({name})
										
										if (#teles > 1) then
											local teletargets = {}
											local targettele = 0
											
											for a,b in ipairs(teles) do
												local tele = mmf.newObject(b)
												
												if (b ~= unit) then
													table.insert(teletargets, b)
												end
											end
											
											if (#teletargets > 0) then
												targettele = teletargets[math.random(#teletargets)]
												local limit = 0
												
												while (targettele == unitid) and (limit < 10) do
													targettele = teletargets[math.random(#teletargets)]
													limit = limit + 1
												end
												
												odata.tele = 1
												
												local tele = mmf.newObject(targettele)
												local tx,ty = tele.values[XPOS],tele.values[YPOS]
												
												MF_particles("glow",vunit.values[XPOS],vunit.values[YPOS],5)
												
												local vunithold = hasfeature(vunit.strings[UNITNAME],"is","hold",v)
												local vunitswap = hasfeature(vunit.strings[UNITNAME],"is","swap",v)
												local imswap = hasfeature(name,"is","swap",unit.fixed)
											
												update(v,tx,ty)
												
												if (vunithold ~= nil) then
													telethis = true
													telethisx = tx
													telethisy = ty
												end
												
												if (vunitswap ~= nil) or (imswap ~= nil) then
													table.insert(swaptele, targettele)
												end
												
												MF_particles("glow",tx,ty,5)
											end
										end
									end
								end
							end
						end
					end
					
					if telethis then
						update(unitid,telethisx,telethisy)
					end
					
					if (#swaptele > 0) then
						for a,b in ipairs(swaptele) do
							update(b,x,y)
						end
					end
				end
				
				if isbest then
					MF_bling(unitid)
					addundo({"bling",name,id})
				end
				
				if ishide and unit.visible then
					unit.visible = false
					addundo({"visibility",name,id,0})
				end
			else
				if (unit.visible == false) then
					unit.visible = true
					addundo({"visibility",name,id,1})
				end
				
				unit.values[A] = 0
			end
		else
			break
		end
	end
	
	if (#delthese > 0) then
		for i,v in ipairs(delthese) do
			local uid = v[1]
			if (deleted[uid] == nil) then
				delete(uid,v[2])
				deleted[uid] = 1
			end
		end
	end
end

function emptyisbest()
	local emptyisbest = hasfeature("empty","is","best",0)
	
	if (emptyisbest ~= nil) then
		MF_blingempty()
		addundo({"blingempty"})
	end
end

function doback(unit,actions)
	local id = unit.values[ID]
	
	if (#actions > 0) then
		for i,line in ipairs(actions) do
			local checkid = 0
			local style = line[1]
			
			if (style == "update") then
				checkid = line[9]
			elseif (style == "remove") then
				checkid = line[6]
			elseif (style == "create") then
				checkid = line[3]
			elseif (style == "bling") then
				checkid = line[3]
			elseif (style == "visibility") then
				checkid = line[3]
			end
			
			if (checkid == id) then
				if (style == "update") then
					local oldx,oldy = unit.values[XPOS],unit.values[YPOS]
					local x,y,dir = line[3],line[4],line[5]
					
					local ox = x-oldx
					local oy = y-oldy
					
					if (math.abs(ox) + math.abs(oy) <= 1) then
						local realdir = rotate(dir)
						
						move(unit.fixed,ox,oy,realdir,true)
						unit.values[DIR] = dir
					else
						unit.values[XPOS] = x
						unit.values[YPOS] = y
						unit.values[DIR] = dir
						unit.values[POSITIONING] = 0
					end
					
					updateunitmap(unitid,oldx,oldy,x,y)
					dynamic(unitid)
					dynamicat(oldx,oldy)
					
					if (unit.strings[UNITTYPE] == "text") then
						updatecode = 1
					end
				elseif (style == "remove") then
					local x,y,dir = line[3],line[4],line[5]
					local name = line[2]
					local newunitid = MF_emptycreate(name,x,y)
					
					local newunit = mmf.newObject(newunitid)
					newunit.values[ONLINE] = 1
					newunit.values[XPOS] = x
					newunit.values[YPOS] = y
					newunit.values[DIR] = dir
					newunit.values[ID] = line[6]
					newunit.flags[9] = true
					
					addunit(newunitid)
					addunitmap(newunitid,x,y)
					dynamic(newunitid)
					
					if (newunit.strings[UNITTYPE] == "text") then
						updatecode = 1
					end
				elseif (style == "create") then
					local x,y = unit.values[XPOS],unit.values[YPOS]
					local unittype = unit.strings[UNITTYPE]

					delunit(unit.fixed)
					MF_remove(unit.fixed,0,0)
					dynamicat(x,y)
					
					if (unittype == "text") then
						updatecode = 1
					end
				elseif (style == "bling") then
					MF_bling(unit.fixed)
				elseif (style == "visibility") then
					if (line[4] == 0) then
						unit.visible = true
					elseif (line[4] == 1) then
						unit.visible = false
					end
				end 
			end
		end
	end
end

function startblock()
	for i,unit in ipairs(units) do
		local name = unit.strings[UNITNAME]
		local unitrules = {}
		
		if (unit.strings[UNITTYPE] == "text") then
			name = "text"
		end
		
		if (featureindex[name] ~= nil) then
			for a,b in ipairs(featureindex[name]) do
				if (b[5] == nil) then
					table.insert(unitrules, {b[1],b[2],b[3][1]})
				else
					if ison({name,b[3]},unitid) then
						table.insert(unitrules, b)
					end
				end
			end
			
			local ishide = isthis(unitrules, "hide")
			local isfollow = xthis(unitrules, "follow")
			
			if ishide then
				if ishide and unit.visible then
					unit.visible = false
				end
			end
			
			if (#isfollow > 0) then
				local x,y = unit.values[XPOS],unit.values[YPOS]
				local distance = 9999
				local targetdir = -1
				
				for i,v in ipairs(isfollow) do
					local these = findall({v})
					
					if (#these > 0) then
						for a,b in ipairs(these) do
							if (b ~= unit.fixed) then
								local funit = mmf.newObject(b)
								
								local fx,fy = funit.values[XPOS],funit.values[YPOS]
								
								local xdir = fx-x
								local ydir = fy-y
								local dist = math.abs(xdir) + math.abs(ydir)
								local fdir = -1
								
								if (math.abs(xdir) <= math.abs(ydir)) then
									if (ydir >= 0) then
										fdir = 3
									else
										fdir = 1
									end
								else
									if (xdir >= 0) then
										fdir = 0
									else
										fdir = 2
									end
								end
								
								if (dist < distance) then
									distance = dist
									targetdir = fdir
								end
							end
						end
					end
				end
				
				if (targetdir >= 0) then
					updatedir(unit.fixed,targetdir)
				end
			end
		end
	end
end

function keyblock()
	local data = ""
	
	if (dokeyblock ~= "") then
		data = dokeyblock
		dokeyblock = ""
		for i,v in ipairs(data) do
			if (#v == 3) then
				local action = v[3][1]
				
				if (action == "win") then
					local yous = findfeature(nil,"is","you")
					local canwin = false
					
					if (yous ~= nil) then
						for a,b in ipairs(yous) do
							local allyous = findall(b)
							
							if (#allyous > 0) then
								canwin = true
								for c,d in ipairs(allyous) do
									local unit = mmf.newObject(d)
									MF_particles("win",unit.values[XPOS],unit.values[YPOS],10)
								end
							end
						end
					end
					
					if canwin then
						MF_win()
					end
				elseif (action == "kill") then
					local yous = findfeature(nil,"is","you")
					
					if (yous ~= nil) then
						for a,b in ipairs(yous) do
							local allyous = findall(b)
							
							if (#allyous > 0) then
								for c,d in ipairs(allyous) do
									if (issafe(d) == false) then
										delete(d,2)
									end
								end
							end
						end
					end
				elseif (action == "weak") then
					local delthese = {}
					
					for k,tile in pairs(unitmap) do
						if (#tile > 1) then
							for a,b in ipairs(tile) do
								if (issafe(b) == false) then
									table.insert(delthese, b)
								end
							end
						end
					end
					
					if (#delthese > 0) then
						for a,b in ipairs(delthese) do
							delete(b,0)
						end
					end
				elseif (action == "hot") then
					local melts = findfeature(nil,"is","melt")
					
					if (melts ~= nil) then
						for a,b in ipairs(melts) do
							local allmelts = findall(b)
							
							if (#allmelts > 0) then
								for c,d in ipairs(allmelts) do
									if (issafe(d) == false) then
										local unit = mmf.newObject(d)
										MF_particles("smoke",unit.values[XPOS],unit.values[YPOS],5)
										delete(d,2)
									end
								end
							end
						end
					end
				elseif (action == "melt") then
					local hots = findfeature(nil,"is","hot")
					
					if (hots ~= nil) then
						for a,b in ipairs(hots) do
							local allhots = findall(b)
							
							if (#allhots > 0) then
								for c,d in ipairs(allhots) do
									if (issafe(d) == false) then
										local unit = mmf.newObject(d)
										MF_particles("smoke",unit.values[XPOS],unit.values[YPOS],5)
										delete(d,2)
									end
								end
							end
						end
					end
				elseif (action == "open") then
					local shuts = findfeature(nil,"is","shut")
					
					if (shuts ~= nil) then
						for a,b in ipairs(shuts) do
							local allshuts = findall(b)
							
							if (#allshuts > 0) then
								for c,d in ipairs(allshuts) do
									if (issafe(d) == false) then
										MF_particles("unlock",unit.values[XPOS],unit.values[YPOS],30)
										delete(d,2)
									end
								end
							end
						end
					end
				elseif (action == "shut") then
					local opens = findfeature(nil,"is","open")
					
					if (opens ~= nil) then
						for a,b in ipairs(opens) do
							local allopens = findall(b)
							
							if (#allopens > 0) then
								for c,d in ipairs(allopens) do
									if (issafe(d) == false) then
										MF_particles("unlock",unit.values[XPOS],unit.values[YPOS],30)
										delete(d,2)
									end
								end
							end
						end
					end
				elseif (action == "sink") then
					local yous = findfeature(nil,"is","you")
					local moves = findfeature(nil,"is","move")
					local pushes = findfeature(nil,"is","push")
					local pulls = findfeature(nil,"is","pull")
					
					if (yous ~= nil) then
						for a,b in ipairs(yous) do
							local allyous = findall(b)
							
							if (#allyous > 0) then
								for c,d in ipairs(allyous) do
									if (issafe(d) == false) then
										delete(d,2)
									end
								end
							end
						end
					end
					
					if (moves ~= nil) then
						for a,b in ipairs(moves) do
							local allmoves = findall(b)
							
							if (#allmoves > 0) then
								for c,d in ipairs(allmoves) do
									if (issafe(d) == false) then
										delete(d,2)
									end
								end
							end
						end
					end
					
					if (pushes ~= nil) then
						for a,b in ipairs(pushes) do
							local allpushes = findall(b)
							
							if (#allpushes > 0) then
								for c,d in ipairs(allpushes) do
									if (issafe(d) == false) then
										delete(d,2)
									end
								end
							end
						end
					end
					
					if (pulls ~= nil) then
						for a,b in ipairs(pulls) do
							local allpulls = findall(b)
							
							if (#allpulls > 0) then
								for c,d in ipairs(allpulls) do
									if (issafe(d) == false) then
										delete(d,2)
									end
								end
							end
						end
					end
				elseif (action == "shift") then
					for a,unit in ipairs(units) do
						local x,y,dir = unit.values[XPOS],unit.values[YPOS],unit.values[DIR]
						local drs = ndirs[dir+1]
						local ox = drs[1]
						local oy = drs[2]
						
						local things = findallhere(x,y)
						
						if (#things > 1) then
							for c,d in ipairs(things) do
								if (d ~= unit.fixed) then
									local newunit = mmf.newObject(d)
									
									if (newunit.values[MOVED] == 0) or (newunit.values[PUSHED] ~= dir) then
										move(d,ox,oy,dir)
									end
								end
							end
						end
					end
				elseif (action == "tele") then
					for a,unit in ipairs(units) do
						local x,y = unit.values[XPOS],unit.values[YPOS]
						
						local things = findallhere(x,y)
						
						if (#things > 1) then
							local teletargets = findall({unit.strings[UNITNAME]})

							if (#teletargets > 1) then
								for c,d in ipairs(things) do
									if (d ~= unit.fixed) then
										local teletargetnum = math.random(1,#teletargets)
										local teletarget_ = teletargets[teletargetnum]
										local teletarget = mmf.newObject(teletarget_)
										local tx,ty = teletarget.values[XPOS],teletarget.values[YPOS]
										
										update(d,tx,ty)
										
										MF_particles("glow",x,y,5)
										MF_particles("glow",tx,ty,5)
									end
								end
							end
						end
					end
				elseif (action == "grow") then
					local unitnum = #units
					
					for c,unit in ipairs(units) do
						if (c <= unitnum) then
							local x,y = unit.values[XPOS],unit.values[YPOS]
							
							for i=1,4 do
								local drs = ndirs[i]
								local ox = drs[1]
								local oy = drs[2]
								
								local valid = true
								local obs = findobstacle(x+ox,y+oy)
								local tileid = x+ox + (y+oy) * roomsize
								
								if (#obs > 0) then
									for a,b in ipairs(obs) do
										if (b == -1) then
											valid = false
										elseif (b > 0) then
											local bunit = mmf.newObject(b)
											local obsname = bunit.strings[UNITNAME]
											local obstype = bunit.strings[UNITTYPE]
											
											if (obstype == "text") then
												obsname = "text"
											end
											
											local obsstop = hasfeature(obsname,"is","stop",b)
											local obspush = hasfeature(obsname,"is","push",b)
											local obspull = hasfeature(obsname,"is","pull",b)
											local obsyou = hasfeature(obsname,"is","you",b)
											
											if (obsstop ~= nil) or (obspush ~= nil) or (obsyou ~= nil) or (obspull ~= nil) or (obsname == name) or (obstype == "text") then
												valid = false
												print(obsname)
											end
											
											--valid = false
										end
									end
								end
								
								if valid then
									copy(unit.fixed,x+ox,y+oy)
								end
							end
						end
					end
				elseif (action == "move") then
					for a,unit in ipairs(units) do
						local x,y,dir = unit.values[XPOS],unit.values[YPOS],unit.values[DIR]
						local drs = ndirs[dir+1]
						local ox = drs[1]
						local oy = drs[2]
						
						if (unit.values[MOVED] == 0) then
							local boop = move(unit.fixed,ox,oy)
							
							if (boop == 1) then
								local newdir = rotate(dir)
								
								drs = ndirs[newdir+1]
								ox = drs[1]
								oy = drs[2]
								
								updatedir(unit.fixed,newdir)
								
								if (unit.values[MOVED] == 0) then
									move(unit.fixed,ox,oy,newdir)
								end
							end
						end
					end
				end
			end
		end
	end
end