function movecommand(ox,oy,dir_)
	local p = findfeature(nil,"is","you")
	local hold = findfeature(nil,"is","hold")
	
	if (dir_ ~= nil) then
		currdir = dir_
	else
		currdir = 4
	end
	
	if (p ~= nil) then
		for a,b in ipairs(p) do
			local players = findall(b)
			
			for i,v in ipairs(players) do
				local unit = mmf.newObject(v)
				local x,y,dir = unit.values[XPOS],unit.values[YPOS],unit.values[DIR]
				local held = 0
				
				if (hold ~= nil) then
					for d,c in ipairs(hold) do
						local holder = findtype(c,x,y,v)
						
						if (#holder > 0) then
							held = 1
						end
					end
				end
				
				if (unit.values[MOVED] == 0) then
					if (held == 0) then
						move(v,ox,oy,dir_)
					else
						updatedir(v,dir_)
					end
				end
			end
		end
	end
end

function move(unitid,ox,oy,dir_,force_,specialrule)
	local unit = mmf.newObject(unitid)
	local x,y,dir = unit.values[XPOS],unit.values[YPOS],unit.values[DIR]
	local name = unit.strings[UNITNAME]
	local thistype = unit.strings[UNITTYPE]
	
	local force = false
	
	if (force_ ~= nil) then
		force = force_
	end
	
	if (thistype == "text") then
		name = "text"
	end
	
	if (dir_ ~= nil) then
		dir = dir_
	end
	
	if (ox ~= 0) or (oy ~= 0) then
		local hm = check(unitid,ox,oy,dir,nil,nil,specialrule)
		local backhm = check(unitid,0-ox,0-oy,dir)
		local done = false
		local weak = hasfeature(name,"is","weak",unitid)
		local swapper = hasfeature(name,"is","swap",unitid)
		local swap = findfeatureat(nil,"is","swap",x+ox,y+oy)
		
		if (specialrule == 2) then
			if (x+ox > 0) and (x+ox < roomsize-1) and (y+oy > 0) and (y+oy < roomsize-1) then
				hm = 0
			end
		end

		while (done == false) do
			if (hm == 0) then
				local hold = findfeature(nil,"is","hold")
				local holder = hasfeature(name,"is","hold",unitid)
				
				if (hold ~= nil) and (thistype ~= "text") then
					for a,b in ipairs(hold) do
						local holdy = findtype(b,x,y,unitid)
						
						if (#holdy > 0) then
							for i,v in ipairs(holdy) do
								if (v > 1) and (v ~= unitid) then
									done = true
									hm = 1
								end
							end
						end
					end
				end
				
				if (holder ~= nil) then
					local holdtargets = findallhere(x,y)
					
					if (#holdtargets > 0) then
						for a,b in ipairs(holdtargets) do
							if (b ~= unitid) then
								update(b,x+ox,y+oy)
							end
						end
					end
				end
				
				if (swapper ~= nil) then
					local swaptargets = findallhere(x+ox,y+oy)
					
					if (#swaptargets > 0) then
						for a,b in ipairs(swaptargets) do
							update(b,x,y)
						end
					end
				end
				
				if (swap ~= nil) then
					for a,b in ipairs(swap) do
						update(b,x,y)
					end
				end
				
				if (done == false) then
					if (unit.values[PUSHED] ~= dir) or force then
						update(unitid,x+ox,y+oy,dir)
						
						if (backhm > 2) then
							move(backhm,ox,oy,dir,false,1)
						elseif (backhm == 2) then
							emptymove(x-ox,y-oy,ox,oy,dir,1)
						end
						
						unit.values[PUSHED] = dir
					end
					
					done = true
					
					if (unit.values[TILING] == 2) then
						unit.values[VISUALDIR] = ((unit.values[VISUALDIR] + 1)+4) % 4
						unit.direction = unit.values[DIR] * 8 + unit.values[VISUALDIR]
					end
					
					if (holder ~= nil) then
						local targets = findallhere(x,y)
						
						if (#targets > 0) then
							for i,v in ipairs(targets) do
								if (v ~= unitid) and (v ~= backhm) then
									update(v,x+ox,y+oy,dir)
								end
							end
						end
					end
				end
			elseif (hm > 1) then
				local hmunit = {}
				local hmx,hmy = x + ox,y + oy
				
				if (hm ~= 2) then
					hmunit = mmf.newObject(hm)
					hmx,hmy = hmunit.values[XPOS],hmunit.values[YPOS]
				end
				
				if (swapper == nil) then
					if (swap == nil) then
						if (x + ox == hmx) and (y + oy == hmy) then
							if (hm ~= 2) then
								hm = move(hm,ox,oy,dir)
								MF_sound(1)
							else
								hm = emptymove(hmx,hmy,ox,oy,dir,0)
							end
						end
					else
						for i,v in ipairs(swap) do
							if (v == hm) then
								hm = 0
							end
						end
						
						if (hm > 1) then
							if (x + ox == hmx) and (y + oy == hmy) then
								if (hm ~= 2) then
									hm = move(hm,ox,oy,dir)
									MF_sound(1)
								else
									hm = emptymove(hmx,hmy,ox,oy,dir,0)
								end
							end
						end
					end
				else
					hm = 0
				end
			else
				done = true
				local swapper = hasfeature(name,"is","swap",unitid)
				local swap = findfeatureat(nil,"is","swap",x+ox,y+oy)
				
				if (swapper ~= nil) then
					local swaptargets = findallhere(x+ox,y+oy)
					
					if (#swaptargets > 0) then
						for a,b in ipairs(swaptargets) do
							update(b,x,y)
							hm = 0
							done = false
						end
					end
				end
				
				if (swap ~= nil) then
					for a,b in ipairs(swap) do
						update(b,x,y)
						hm = 0
						done = false
					end
				end
			end
		end
		
		if (hm == 1) and (weak ~= nil) and (issafe(unitid) == false) then
			if (unit.values[MOVED] == 0) then
				delete(unitid,4)
				hm = 0
			end
		end
		
		return hm
	end
end
	
function check(unitid,ox,oy,dir,x_,y_,specialrule_)
	local unit = {}
	local x,y = 0,0
	local unitname = ""
	local specialrule = 0
	
	if (specialrule_ ~= nil) then
		specialrule = specialrule_
	end
	
	if (unitid ~= 2) then
		unit = mmf.newObject(unitid)
		x,y = unit.values[XPOS],unit.values[YPOS]
		unitname = unit.strings[UNITNAME]
		
		if (unit.strings[UNITTYPE] == "text") then
			unitname = "text"
		end
	else
		unitname = "empty"
		x = x_
		y = y_
	end
	
	local result_ = findobstacle(x+ox,y+oy)
	local final = 0
	
	local emptypush = findfeature("empty","is","push")
	local emptypull = findfeature("empty","is","pull")
	local emptystop = findfeature("empty","is","stop")
	
	local imyou = hasfeature(unitname,"is","you",unitid)
	
	local pull = 0
	local drs = ndirs[dir + 1]
	local dirox = drs[1]
	local diroy = drs[2]
	
	if (dirox ~= ox) or (diroy ~= oy) then
		pull = 1
	end
	
	if (#result_ > 0) then
		for i,v in ipairs(result_) do
			local result = v
			if (result > 1) then
				local resultunit = mmf.newObject(result)
				local type = resultunit.strings[UNITTYPE]
				local name = resultunit.strings[UNITNAME]
				
				if (type == "text") then
					name = type
				end
				
				local ispush = hasfeature(name,"is","push",result)
				local isstop = hasfeature(name,"is","stop",result)
				local ispull = hasfeature(name,"is","pull",result)
				local isyou = hasfeature(name,"is","you",result)
				local ismove = hasfeature(name,"is","move",result)
				
				local isweak = hasfeature(name,"is","weak",result) or hasfeature(unitname,"is","weak",unitid)
				
				if (type == "text") and (ispush == nil) then
					ispush = "done"
				end
				
				if (pull == 0) and (isweak == nil) then
					local doors = findfeature(nil,"is","shut")
					local keys = findfeature(nil,"is","open")
					local door = 0
					local key = 0
					
					if (doors ~= nil) and (keys ~= nil) then
						for a,b in ipairs(doors) do
							if (unitname == b[1]) and (unitid ~= 2) then
								if ison(b,unitid) then
									door = unitid
								end
							end
							
							if (name == b[1]) then
								if ison(b,result) then
									door = v
								end
							end
						end
						
						for a,b in ipairs(keys) do
							if (unitname == b[1]) and (unitid ~= 2) then
								if ison(b,unitid) then
									key = unitid
								end
							end
							
							if (name == b[1]) then
								if ison(b,result) then
									key = v
								end
							end
						end
						
						if (door > 0) and (key > 0) then
							if (issafe(door) == false) then
								if (door == unitid) then
									MF_particles("unlock",x,y,15)
								elseif (door == v) then
									MF_particles("unlock",resultunit.values[XPOS],resultunit.values[YPOS],15)
								end
								delete(door,3)
								result = 0
							end
							
							if (issafe(key) == false) then
								if (key == unitid) then
									MF_particles("unlock",x,y,15)
								elseif (key == v) then
									MF_particles("unlock",resultunit.values[XPOS],resultunit.values[YPOS],15)
								end
								delete(key,0)
								result = 0
							end
						end
					end
				end
				
				if ((ispush ~= nil) and (pull == 0)) or ((ispull ~= nil) and (pull == 1)) then
					if (v ~= -1) then
						final = result
					end
				else
					if (isstop ~= nil) or ((ispull ~= nil) and (pull == 0)) then
						final = 1
					end
				end
				
				-- Tästä otettiin stop pois pushin luota
				if (final >= 1) and (isyou ~= nil) and ((ispush ~= nil) or ((imyou ~= nil) and (isstop ~= nil))) and (pull == 0) then
					final = result
				end
				
				if (final >= 1) and (ismove ~= nil) and ((isstop ~= nil) or (ispush ~= nil)) then
					--final = result
				end
			end
			
			if (v == -1) then
				final = 1
			end
		end
	end
	
	if (final == 0) and (#result_ == 0) then
		if (emptystop ~= nil) or ((emptypull ~= nil) and (pull == 0) and (specialrule ~= 1)) then
			final = 1
		end
		
		if (emptypush ~= nil) or ((emptypull ~= nil) and (pull == 1)) then
			final = 2
		end
	end

	return final
end

function emptymove(x,y,ox,oy,dir,pull,specialrule)
	local hm = 0
	local backhm = 0

	if (pull == 1) then
		backhm = check(2,0-ox,0-oy,dir,x,y)
	else
		hm = check(2,ox,oy,dir,x,y,specialrule)
	end
	
	local done = false
	
	local newx,newy = x+ox,y+oy
	
	while (done == false) do
		if (hm == 0) then
			done = true
			
			if (backhm > 1) then
				if (backhm == 2) then
					backhm = emptymove(x-ox,y-oy,ox,oy,dir,1)
				else
					backhm = move(backhm,ox,oy,dir,false,1)
				end
			end
		elseif (hm > 1) then
			if (hm == 2) then
				MF_debug(x,y,1)
				hm = emptymove(newx,newy,ox,oy,dir,0)
			else
				hm = move(hm,ox,oy,dir)
			end
		elseif (hm == 1) then
			done = true
		end
	end

	return hm
end
			
function movecount()
	for i,unit in ipairs(units) do
		local name = unit.strings[UNITNAME]
		
		local moves = 0
		local basemove = 0
		
		if (featureindex[name] ~= nil) then
			for a,rule in ipairs(featureindex[name]) do
				local ruletype = ""
				
				if (#rule == 3) then
					ruletype = rule[3][1]
				elseif (#rule == 5) then
					local test = rule[3]
					
					if (test == nil) or (ison({rule[1],test},unit.fixed)) then
						ruletype = rule[5]
					end
				end
					
				if (ruletype == "push") or (ruletype == "pull") then
					basemove = 1
				end
				
				if (ruletype == "you") or (ruletype == "move") then
					moves = moves + 1
				end
			end
		end
		
		if (moves == 0) then
			unit.values[MOVED] = basemove
		else
			unit.values[MOVED] = moves
		end
		
		unit.values[MOVED] = 0
	end
end
	